unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  {$ifdef Thread} LCLProc, {$endif}
  Menus, BCLabel, ubarcodes, BGRABitmap, BGRABitmapTypes,
  {$ifdef With_VideoCard}
  VideoCapture, videodev2, YUV2RGB,
  {$endif}

  {$ifdef With_VideoFile}
  // Units 4 vlc-Video
  lclvlc, vlc, libvlc,
  {$endif}

  { User - Units }
  ufunction, uconst
  {$ifdef QR_Prog}, QR4OBS
  {$endif};

type
  TCUEFile                   = record
    Phad, Filename           : string;
    end;
  TCUEData                   = array of record
    Track                    : String;


  end;

  {$ifdef Thread}
  { HauptThread }
  // Hier wird nur der Titel abgefragt.
  TBaseThread                = class(TThread)
  public
    procedure Execute;         override;
    procedure ReadTitel;
  end;

  { QR_Thread }
  // Hier werden alle QRs gesteuert
  TQRThread                  = class(TThread)
  public
    Wait4Video               : PRtlEvent;
//    procedure Execute;       override;
  end;

  { VLC_Thread }
  // Wenn Track-ID passt und entsprechende Videos auf dem OBS-Rechner vorhanden sind
  // übernimmt dieser Thread seine Arbeit, Andernfalls bleibt er Inaktiv
  TVLCThread                = class(TThread)
  public
//    procedure VLCLoad(Vod: String);
//    procedure VLCPlay(Sender: TObject);
//    procedure Execute;       override;
  end;
  {$endif}

  { TForm1 }

  TForm1                     = class(TForm)
    BCLabel1                 : TBCLabel;
    Button1                  : TButton;
    Panel1                   : TPanel;
    Texte1, Texte2, Texte3   : TLabel;
    PaintBox1                : TPaintBox;
    TrackTime                : TTimer;

    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender : TObject);

  {$ifdef QR_Prog}
    procedure QR_Edit(Sender: TObject);
  {$endif}
    procedure TrackTime_Run(Sender: TObject);

    procedure RadioGroup1Click(Sender :TObject);

  {$ifdef With_VideoCard}
    procedure SelectVideoCard(Sender: TObject);
    procedure VideoFrameSynchronized(Sender : TObject; Buffer : pointer;
      Size : integer; Error : boolean);
  {$endif}

  private
    // Thread Spezische Kombonenten
    ACriticalSection: TRTLCriticalSection;

    // Components
    s, QR_Text               : TStringList;
    {$ifdef With_VideoCard}
    BMP                      : TBitmap;
    {$endif}

    // Types
    CUEFile                  : TCUEFile;

    // Var as number
    _2X, _2Y, _i             : Byte;
    ReadTime                 : word;
    QR_Time                  : int64;
    {$ifdef With_VideoCard}
    prevTicks                : QWord;
    {$endif}

    // var as bool
    Up, Manuell, Auto_QR     : boolean;

    // var as letter
    MTrackFile               : String;

  public
    Screen                   : TScreen;
    DirectoryDialog          : TSelectDirectoryDialog;
    QR                       : TBarcodeQR;
    {$ifdef With_VideoCard}
    VideoCard                : TComboBox;
    Video                    : TVideo4L2Device;
    {$endif}

    {$ifdef With_VideoFile}
    VLC                      : TLCLVLCPlayer;
    {$endif}
    Button                   : {array [1..2] of }TButton;
    RadioGroup               : array [1..2] of TRadioGroup;

    {$ifdef Thread}
    BaseThread               : TBaseThread;
    QRThread                 : TQRThread;
    VLCThread                : TVLCThread
    {$endif}
  end;

const
  {$if defined (VJ)}
//  TrackFile                  = Array [0..1] of String = ('/run/user/1000/gvfs/smb-share:server=dj-rechner.local,share=musik/Mixxx/NOW-PLAYING/mixxx-now-playing-master/mixxx-now-playing.txt',
//                                                         '/run/user/1000/gvfs/smb-share:server=192.168.188.6,share=musik/Mixxx/NOW-PLAYING/mixxx-now-playing-master/mixxx-now-playing.txt');
  TrackFile                  = '/run/user/1000/gvfs/smb-share:server=vj-system.local,share=musik/Mixxx/NOW-PLAYING/mixxx-now-playing-master/mixxx-now-playing.txt';
  VideoFile                  = '';
  {$elseif defined (DJ)}
  TrackFile                  : Array [0..1] of String = ('/run/user/1000/gvfs/smb-share:server=dj-rechner.local,share=musik/Mixxx/NOW-PLAYING/mixxx-now-playing-master/mixxx-now-playing.txt',
                                                         '/run/user/1000/gvfs/smb-share:server=192.168.188.6,share=musik/Mixxx/NOW-PLAYING/mixxx-now-playing-master/mixxx-now-playing.txt');
  VideoFile                  = '';
  {$elseif defined (Prog)}
  TrackFile                  = '/home/vamlyktan/mixxx-now-playing';
  VideoFile                  = '/home/vamlyktan/Videos/VamLykTan';
  {$elseif defined Run}
  TrackFile                  = '/home/vamlyktan/mixxx-now-playing.txt';
  VideoFile                  = '/home/vamlyktan/Videos/VamLykTan';
  {$endif}


var
  Form1                      : TForm1;
  i                          : byte;
  QR_Break                   : Boolean = False;
  Clear_Text                 : String;

implementation

{$R *.lfm}

{$ifdef Thread}
{ BaseTHread }

Procedure TBaseThread.ReadTitel;
var Temp                     : String;
begin
  EnterCriticalsection(Form1.ACriticalSection);
  with Form1 do begin
    if     Manuell then Temp := MTrackFile;
    if not Manuell then Temp :=  TrackFile;
    if FileExists(Temp) then
      s.LoadFromFile(Temp);
    end;
  Form1.Caption              := 'Ich bin nun im BaseThread';;
//  Form1.TrackTime.Enabled    := true;
  LeaveCriticalsection(Form1.ACriticalSection);
end;

{$endif}

{ TForm1 }

procedure TForm1.RadioGroup1Click(Sender : TObject);
//var Temp                     : String;
begin
  Manuell                    := True;
  Readtime                   := 0;
  s.Clear;
  case RadioGroup[1].Items[RadioGroup[1].ItemIndex] of
    '-> Lokal (Entwicklung)'      : begin
                                    MTrackFile             := '/home/vamlyktan/mixxx-now-playing';
                                    CueFile.Phad           := '/home/vamlyktan/Musik/Mixxx/Recordings/VamLykTan/20';
                                    end;
    '-> Lokal'                    : begin
                                    MTrackFile             := '/home/vamlyktan/mixxx-now-playing.txt';
                                    CueFile.Phad           := '/home/vamlyktan/Musik/Mixxx/Recordings/VamLykTan/20';
                                    end;
    '-> Netzwerk - DJ'            : begin
                                    MTrackFile             := '/run/user/1000/gvfs/smb-share:server=dj-system.local,share=dj-rechner/Mixxx/NOW-PLAYING/mixxx-now-playing-master/mixxx-now-playing.txt';
                                    CueFile.Phad           := '/run/user/1000/gvfs/smb-share:server=dj-system.local,share=dj-rechner/Musik/Mixxx/Recordings/VamLykTan/20';
                                    end;
    '-> Netzwerk - VJ'            : begin
                                    MTrackFile             := '/run/user/1000/gvfs/smb-share:server=vj-system.local,share=vj-rechner/Mixxx/NOW-PLAYING/mixxx-now-playing-master/mixxx-now-playing.txt';
                                    CueFile.Phad           := '/run/user/1000/gvfs/smb-share:server=vj-system.local,share=vj-rechner/Musik/Mixxx/Recordings/VamLykTan/20';
                                    end;
{    '--> Mix by VamLykTan 2023'   : begin
                                    DirectoryDialog        := TSelectDirectoryDialog.Create(NIL);
//                                    if DirectoryDialog.Execute then
                                       with DirectoryDialog do begin
                                          Filter            := 'Cue-File|*.cue';
                                          InitialDir        := CUEFile.Phad;
                                      Temp                  := InitialDir + IntToStr(23);
                                      end;
///                                    with RadioGroup[2] do begin
//                                      Autofill             := True;
//                                      Autosize             := True;
//                                      Left                 := 20 + RadioGroup[1].Width;
//                                      Caption              := 'Playing Mixe by VamLykTan';
//                                      Items.Add(' -> 100 % Elektro');
//                                      Items.Add(' -> Gothic Rock 01');
//                                      Items.Add(' -> New Year''s Eve Metal 22_23');
//                                      Top                  := Form1.Height - Height - 50;
//                                      Parent               := Form1;
                                      DirectoryDialog.Free;
//                                      end;
                                    //Form1.Caption          := IntToStr(RadioGroup[2].Top) + ' | ' + IntToStr(RadioGroup[2].Left);
                                    end;      }
    end;
//  Form1.Caption                                            := temp;
end;

{$ifdef QR_Prog}
Procedure TForm1.QR_Edit(Sender: TObject);
begin
  Form2.show;
//                                Local Test
//  Caption                         := IDE_Load('/usr/bin/', 'nautilus', ['/home/vamlyktan/Entwicklung', '/home/vamlyktan/Musik', '/home/vamlyktan/.config'], []);
//                                Network Test
  Caption                         := _IDE_Load('/usr/bin/', 'nautilus', ['smb://192.168.188.6/musik/Mixxx/NOW-PLAYING/mixxx-now-playing-master/'], []);
end;
{$endif}

{$ifdef With_VideoCard}
procedure TForm1.SelectVideoCard(Sender: TObject);
begin
  with Video do begin
    BufferCount              := 4;
    Device                   := VideoCard.Text;
    fourCC                   := 'YUYV';
    FrameRate                := 25;
    Height                   := 480;
    PixelFormat              := 1448695129;
    Width                    := 640;
    OnFrameSynchronized      := @VideoFrameSynchronized;
    end;
end;

procedure TForm1.VideoFrameSynchronized(Sender : TObject; Buffer : pointer;
  Size : integer; Error : boolean);
var ticks:QWord;
begin
  if Size<>(PaintBox1.Width*PaintBox1.Height*2{YUYV}) then begin
    //LabelError.Caption:='Invalid buffer length '+IntToStr(Size);
  end;
{  if Error then begin
    LabelError.Caption:='Frame with recoverable error received';
  end;    }

  BMP.BeginUpdate;
  YUYV_to_BGRA(PLongWord(Buffer), PLongWord(BMP.RawImage.Data), BMP.Width*BMP.Height);
  BMP.EndUpdate;
  PaintBox1.Canvas.Draw(0,0,BMP);

  ticks:=GetTickCount64;
//  StatusBar.SimpleText:=IntToStr(round(1000.0/(ticks-prevTicks)))+' FPS';
//  StatusBar.Refresh;
  prevTicks:=ticks;
end;
{$endif}

procedure TForm1.FormCreate(Sender: TObject);
var dev, fdev                : byte;
begin
//  InitCriticalSection(ACriticalSection);
  Auto_QR                    := True;
  Manuell                    := False;
  _2X                        := 0;
  _2Y                        := 0;
  UP                         := True;
  ReadTime                   := 0;
  dev                        := 0;
  fdev                       := 1;

  // Komponenten, welche keine Arrays bedürfen
  {$ifdef With_VideoCard}
  BMP                        := TBitmap.Create;
  VideoCard                  := TComboBox.Create(NIL);
  Video                      := TVideo4L2Device.Create(NIL);

  with BMP do begin
    Width                    := PaintBox1.Width;
    Height                   := PaintBox1.Height;
    PixelFormat              := pf24bit; // Byte order: BGR. pf32bit gives inverted RGB order for some reason
    end;
  with VideoCard do begin
    repeat
      if FileExists('/dev/video' + intToStr(dev)) then begin
//        VideoCard.Items.Add('/dev/usb/hiddev' + intToStr(fdev-1));
        VideoCard.Items.Add('/dev/video' + intToStr(fdev-1));
        inc(fdev);
      end;
      inc(dev);
      until dev <= 10;
    Height                   := 30;
    Left                     := 500;
    Top                      := 200;
    Width                    := 300;
    Parent                   := Form1;
//    Form1.Caption            := IntToStr(fdev-1) + ' Geräte erfolgreich gefunden';
    OnClick                  := @SelectVideoCard;
    end;
  {$endif}
  s                          := TStringList.Create;
  QR_Text                    := TStringList.Create;

  for I := 0 to High(TT4OBS_QR.Text) do
    QR_Text.Add(TT4OBS_QR.Text[i]);
//  Caption                    := IntToStr(High(TT4OBS_QR.Text));
  Screen                     := TScreen.Create(NIL);
  QR                         := TBarcodeQR.Create(NIL);
  with Form1 do begin
//    Caption                  := 'Track - to - OBS';
    Width                    := 1000;
    Color                    := $0026267B;   // $001C78E9
    if Screen.MonitorCount > 1 then begin
       Left                  := 1354;
       Top                   := 967;
       Font.Name             := '18 Holes BRK';//'28 Days Later';
       end else begin
         Left                := 0;
         Top                 := 622;
         Font.Name           := '18 Holes BRK';//'DamnedDeluxe';
         end;
    end;
  with BCLabel1 do begin
    Align                    := alTop;
    with Background do begin
      Color                  := $0026267B;
      ColorOpacity           := 80;
      with Gradient1 do begin
        EndColor             := clMaroon;
        EndColorOpacity      := 255;
        Point1XPercent       := 50;
        Point1YPercent       := 50;
        Point2XPercent       := 0;
        Point2YPercent       := 0;
        Sinus                := True;
        end;
      end;
    with FontEx do begin
      Color                  := $0000A7FF;
      Name                   := '18 Holes BRK';
      end;
    end;
  with Texte2 do begin
    Alignment                := taCenter;
    Left                     := 500 - (Canvas.TextWidth(Umlaut_Kill('ERROR Enter EXIT - File Not Found')) div 2);
    Top                      := BCLabel1.Top;
    Height                   := 60;
    with font do begin
      Name                   := 'DamnedDeluxe';
      Size                   := -15;
      Color                  := $0000A7FF;
      Name                   := 'DamnedDeluxe';
      end;
    Transparent              := True;
    end;
  with PaintBox1 do begin
    Height                   := 60;
    Left                     := 900;
    Top                      := 19;
    Width                    := 60;
    end;
  with QR do begin
    BackgroundColor          := clWhite;
    Cursor                   := crNo;
    ECCLevel                 := eBarcodeQR_ECCLevel_H;
    ForegroundColor          := clBlack;
    Height                   := 125;
    Left                     := 15;
    StrictSize               := False;
    Text                     := 'https://www.paypal.com/donate/?hosted_button_id=JWHXZ5MATXQY6';
    Top                      := 15;
    Width                    := 125;
    Parent                   := Form1;
    {$ifdef QR_Prog}
    OnClick                  := @QR_Edit;
    {$endif}
    end;
  {$ifdef With_VideoFile}
  VLC.ParentWindow           := Panel1;
  {$endif}
  _i                         := 0;
end;

procedure TForm1.FormResize(Sender : TObject);
begin
  // Komponenten, welche als Array genutzut werden könnten.
  Button                     := TButton.Create(NIL);
  for i:= 1 to 2 do
    RadioGroup[i]            := TRadioGroup.Create(NIL);

  with RadioGroup[1] do begin
    AutoFill                 := True;
    AutoSize                 := True;
    Left                     := 8;
//    Height                   := 144;
    Caption                  := ' Mixxx Quelle (VamLykTan Mixe) or Live ';
    Parent                   := Form1;
    with ChildSizing do begin
      LeftRightSpacing       := 6;
      EnlargeHorizontal      := crsHomogenousChildResize;
      EnlargeVertical        := crsHomogenousChildResize;
      ShrinkHorizontal       := crsScaleChilds;
      ShrinkVertical         := crsScaleChilds;
      Layout                 := cclLeftToRightThenTopToBottom;
      ControlsPerLine        := 1;
      end;
    with Font do begin
      Color                  := clFuchsia;
      Name                   := '18 Holes BRK';
      end;
    Items.Add('-> Lokal (Entwicklung)');
    Items.Add('-> Lokal');
    Items.Add('-> Netzwerk - DJ');
    Items.Add('-> Netzwerk - VJ');
    Items.Add('--> Mix by VamLykTan');
//    Top                      := Form1.Height - Height;
    Top                      := QR.Top + QR.Height + 10;
    OnClick                  := @RadioGroup1Click;
    end;
  TrackTime.Enabled          := True;
  end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ReadTime                   := 0;
end;

procedure TForm1.TrackTime_run(Sender: TObject);
var Temp                               : String;
begin
  if     Manuell then Temp             := MTrackFile;
  if not Manuell then begin
    if FileExists(TrackFile[0]) then
      Temp                             :=  TrackFile[0];
    if FileExists(TrackFile[1]) then
      Temp                             :=  TrackFile[1];
    S.LoadFromFile(Temp);
    inc(ReadTime);
    Button1.Caption                    := '&Read ' + intToStr(150 - ReadTime);
    if ReadTime = 150 then
      ReadTime                         := 0;
    if S.Capacity <> 0 then begin
      BCLabel1.Visible                 := True;
      Clear_Text                       := '';
      {#Todo - Label Track ID 2 Zeilig über 2tes Label}
      with Texte2 do begin
        Caption                        := Umlaut_Kill(S[0]);
        Left                           := (BCLabel1.Width - Texte2.Width) div 2;
        Top                            := 35;
        Alignment                      := taCenter;
        end;
      BCLabel1.Background.Gradient1.Point1xPercent := _2X;
      if up = True then begin
        if _2X < 100 then
          inc(_2X)
        else Up                        := False;
        end;
      if up = False then begin
        if _2X > 0 then
          dec(_2X)
        else Up                        := True;
        end;
     Caption                           := Clear_Text;
     if S[0] = 'OST+FRONT - HONKA HONKA           ' then begin
        QR_Break                       := True;
        QR.Text                        := TT4OBS_Video.Text[0];
        Texte3.Caption                 := ' <-' + TT4OBS_Video.Name[0];
        QR_Time                        := 0;
        end
        else if S[0] = 'OOMPH! - AUGEN AUF           ' then begin
          QR_Break                     := True;
          QR.Text                      := TT4OBS_Video.Text[1];
          Texte3.Caption               := ' <-' + TT4OBS_Video.Name[1];
          QR_Time                      := 0;
          end
          else if S[0] = 'BEL EPOQ - RAIN IN JULY           ' then begin
            QR_Break                   := True;
            QR.Text                    := TT4OBS_Video.Text[2];
            Texte3.Caption             := ' <-' + TT4OBS_Video.Name[2];
            QR_Time                    := 0;
            end
            else if S[0] = 'HELDMASCHINE - R           ' then begin
              QR_Break                 := True;
              QR.Text                  := TT4OBS_Video.Text[3];
              Texte3.Caption           := ' <-' + TT4OBS_Video.Name[3];
              QR_Time                  := 0;
              end
              else if S[0] = 'SOKO FRIEDHOF - TOTENGRÄBER           ' then begin
                QR_Break               := True;
                QR.Text                := TT4OBS_Video.Text[4];
                Texte3.Caption         := ' <-' + TT4OBS_Video.Name[4];
                QR_Time                := 0;
                end
                else if S[0] = 'FRONTANGEL - UND WIR TANZEN           ' then begin
                  QR_Break             := True;
                  QR.Text              := TT4OBS_Video.Text[5];
                  Texte3.Caption       := ' <-' + TT4OBS_Video.Name[5];
                  QR_Time              := 0;
                  end
                  else QR_Break        := false;
      if not QR_Break then begin
        if QR_Time = 0 then begin
          QR_Time                      := 1500;
          if _i = 9 then _i            := 0;
          QR.Text                      := TT4OBS_QR.Text[_i];
          Texte3.Caption               := ' <-' + TT4OBS_QR.Name[_i];
          inc(_i);
          end;
        dec(QR_Time);
        end;
      end;
    end
    else begin
      BCLabel1.Visible                 := False;
      Texte2.Caption                   := Umlaut_Kill('ERROR Enter EXIT - File Not Found');
      end;
end;

end.



