unit QR4OBS;

{$mode ObjFPC}{$H+}

interface

uses
  { Units welche Komponenten enthalten}
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Menus, ubarcodes,
  { Units welche gesammelte Funktinen enthalten}
  set_data, uconst, iniFiles;
  { Units welche Selbstgeschriebene classen enthalten}

type

{  TQR4                            = array [0..100] of record
    Link, Name                    : String;
    number                        : byte;
    Genre, ID                     : array [0..1] of boolean;  {0 = in file; 1 = not in file}
  end;}

  { TForm2 }

  TForm2 = class(TForm)

    Procedure FormCreate(Sender : TObject);
    Procedure FormKeyDown(Sender : TObject; var Key : Word; Shift : TShiftState);
    procedure FormShow(Sender : TObject);

    Procedure QR_GenreOnChange(Sender: TObject);

    Procedure SaveOnClick(Sender: TObject);
    Procedure BackOnClick(Sender: TObject);
    Procedure NextOnClick(Sender: TObject);
    Procedure DelOnClick(Sender: TObject);
    Procedure ExitOnClick(Sender: TObject);
    Procedure HelpOnClick(Sender: TObject);

  private
    QR                       : TBarcodeQR;

    Button                   : Array [0..5] of TButton;
    QR_Genre                 : Array [0..3] of TCheckBox;
    QR_Data                  : Array [0..1] of TLabeledEdit;

  public
    _QR4OBS                  : TVeeJee_QR4OBS;
    QR4                      : TQR;
    
    QR_index		     : byte;

  end;

var
  Form2                      : TForm2;

  i                          : byte;

implementation

{$R *.lfm}

{ TForm2 }

procedure TForm2.FormCreate(Sender : TObject);
begin
  _QR4OBS                    := TVeeJee_QR4OBS.Create;
  QR                         := TBarcodeQR.Create(NIL);
  QR_index                   := 0;
  for i:= 0 to 4 do begin
    Button[i]                := TButton.Create(NIL);
    Button[i].Height         := 30;
    Button[i].Top            := 136;
    Button[i].Width          := 75;
    Button[i].Parent         := Form2;
    end;

  for i := 0 to 2 do begin
    QR_Genre[i]              := TCheckBox.Create(NIL);
    QR_Genre[i].AutoSize     := false;
    QR_Genre[i].Enabled      := false;
    QR_Genre[i].Left         := 216;
    QR_Genre[i].Width        := 200;
    QR_Genre[i].Height       := 22;
    QR_Genre[i].Parent       := Form2;

    QR_Genre[i].OnChange     := @QR_GenreOnChange;
    end;

  for i := 0 to 1 do begin
    QR_Data[i]               := TLabeledEdit.Create(NIL);
    QR_Data[i].AutoSelect    := True;
    QR_Data[i].AutoSize      := False;
    QR_Data[i].Color         := clRed;
    QR_Data[i].Height        := 29;
    QR_Data[i].Left          := 8;
    QR_Data[i].Parent        := Form2;
    end;

  with QR do begin
    Cursor                   := crNo;
    Height                   := 128;
    Left                     := 500;
    StrictSize               := false;
    Top                      := 12;
    Width                    := 128;
    Parent                    := Form2;
    end;

  { Forumaufbau der Buttons }
 with Button[0] do begin
    Caption                  := '&Speichern';
    Enabled                  := False;
    Hint                     := 'Übertragen der' + CRLF +
                                'Datensätze und Schließt' + CRLF +
                                'das Formular';
    Left                     := 8;

    OnClick                  := @SaveOnClick;
    end;

  with Button[1] do begin
    Caption                  := '&>';
    Enabled                  := False;
    Hint                     := 'Nächter Datensatz';
    Left                     := 88;

    OnClick                  := @NextOnClick;
    end;

  with Button[2] do begin
    Caption                  := '&<';
    Enabled                  := False;
    Hint                     := 'Datensatz zurück';
    Left                     := 168;

    OnClick                  := @BackOnClick;
    end;

  with Button[3] do begin
    Caption                  := '&Löschen';
    Enabled                  := False;
    Hint                     := 'Löscht den ausgewählten' + CRLF +
                                'Datensatz';
    Left                     := 248;

    OnClick                  := @DelOnClick;
    end;

  with Button[4] do begin
    Caption                  := 'A&bbrechen';
    Hint                     := 'Schließt das Formular';
    Left                     := 328;

    OnClick                  := @ExitOnClick;
    end;

{ Formaufbau QR_Genre }
  
  with QR_Genre[0] do begin
    Caption                  := '&Rock/Metal/NDH && Gothic';
    Top                      := 64;
    end;
    
  with QR_Genre[1] do begin
    Caption                  := '&Electro in the Evening';
    Top                      := 86;
    end;

  with QR_Genre[2] do begin
    Caption                  := 'Events and &Gigs';
    Top                      := 112;
    end;
    

  { Formaufbau QR_Data }
  with QR_Data[0] do begin
    EditLabel.Caption        := 'Link-Adresse für QR...';
    Top                      := 24;
    Width                    := 472;
    end;

  with QR_Data[1] do begin
    EditLabel.Caption        := 'Name des QR...';
    Top                      := 80;
    Width                    := 160;
  end;
end;

procedure TForm2.FormKeyDown(Sender : TObject; var Key : Word;
  Shift : TShiftState);
begin
  if  Key = GShortkey_Alt_Abbrechen                         then ExitOnClick(Sender);               // ALT + A
  if (Key = GShortKey_Back[1]) or (key = GShortKey_Back[2]) then BackOnClick(Sender);               // ALT+B / ALT+< (OEM_0xE1)
  if  Key = GShortKey_Alt_Del                               then DelOnClick(Sender);                // ALT+L
  if (Key = GShortkey_Next[1]) or (Key = GShortkey_Next[2]) then NextOnClick(Sender);               // ALT+N / ALT+> (OEM_0xE1)
  if  Key = GShortKey_Alt_Save                              then SaveOnClick(Sender);               // Alt+S

end;

procedure TForm2.FormShow(Sender : TObject);
var I, ID                    : word;
begin
  if FileExists(_QR4OBS.PConst.fFilename+'.QRD') then begin
//    for ID := 0 to 100 do begin
      QR4                         := _QR4OBS.fQR_Data;
//      Memo1.Lines.Add('Link: ' + _QR4OBS.fQR_Data[ID].Link);
//      Memo1.Lines.Add('Name: ' + _QR4OBS.fQR_Data[ID].Name);
//      Memo1.Lines.Add('Rock: ' + _QR[ID].Genre[0]);
//      Memo1.Lines.Add('Electro: ' + _QR[ID].Genre[1]);
//      Memo1.Lines.Add('');
      Caption                   := _QR4OBS.PConst.fFilename+'.QRD';
      end else Caption := _QR4OBS.PConst.fFilename+'.QRD Not Found';
end;

Procedure TForm2.QR_GenreOnChange(Sender: TObject);
begin
  _QR4OBS.fQR_Genre[0]       := QR_Genre[0].Checked;
  _QR4OBS.fQR_Genre[1]       := QR_Genre[1].Checked;
  _QR4OBS.fQR_Genre[2]       := QR_Genre[2].Checked;
end;
{  TQR4                            = array [0..100] of record
    Link, Name                    : String;
    Genre                         : array [0..1] of Boolean;
    ID                            : record of
      number                      : byte;
      _set																	: Boolean;}
Procedure TForm2.SaveOnClick(Sender: TObject);
begin
  
end;

Procedure TForm2.BackOnClick(Sender: TObject);
begin

end;

Procedure TForm2.NextOnClick(Sender: TObject);
begin
  
end;

Procedure TForm2.DelOnClick(Sender: TObject);
begin

end;

Procedure TForm2.ExitOnClick(Sender: TObject);
begin
  Close;
end;

Procedure TForm2.HelpOnClick(Sender: TObject);
begin

end;

end.

ink;
      QR_Data[1].Text        := _QR[0].Name;
      QR_Genre[0].Checked    := _QR[0].Genre[0];
      QR_Genre[1].Checked    := _QR[0].Genre[1];
      end;
    end;
end;

Procedure TForm2.QR_GenreOnChange(Sender: TObject);
begin
  _QR4OBS.fQR_Genre[0]       := QR_Genre[0].Checked;
  _QR4OBS.fQR_Genre[1]       := QR_Genre[1].Checked;
end;

Procedure TForm2.SaveOnClick(Sender: TObject);
begin
  
end;

Procedure TForm2.BackOnClick(Sender: TObject);
begin

end;

Procedure TForm2.NextOnClick(Sender: TObject);
var i : byte;
begin
  i
